## vala-panel-appmenu 0.7.3+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.6 FATAL_ERROR)
cmake_policy (VERSION 3.6)
project (vala-panel-appmenu C)
enable_testing ()
include(GNUInstallDirs)
include(FeatureSummary)
set (DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/vala-panel")
set (PKGDATADIR "${DATADIR}")
set (GETTEXT_PACKAGE "vala-panel-appmenu")
set (RELEASE_NAME "Vala Panel Application Menu")
set (PREFIX ${CMAKE_INSTALL_PREFIX})
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
if(EXISTS ${CMAKE_SOURCE_DIR}/cmake/VCMSubmodule.cmake)
    include(${CMAKE_SOURCE_DIR}/cmake/VCMSubmodule.cmake)
    use_vcm(${CMAKE_SOURCE_DIR}/cmake)
else()
    find_package(VCM REQUIRED NO_MODULE)
    list(APPEND CMAKE_MODULE_PATH ${VCM_MODULE_PATH})
endif()
include(GitVersion)
determine_fallback_version(${CMAKE_SOURCE_DIR}/cmake)
include(${CMAKE_SOURCE_DIR}/cmake/FallbackVersion.cmake)
include(Format)

# Add 'make dist' command for creating release tarball
set (CPACK_PACKAGE_VERSION ${VERSION})
set (CPACK_PACKAGE_RELEASE "1")
set (CPACK_SOURCE_GENERATOR "TXZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_IGNORE_FILES "/build/;/.gitmodules;/.git;/.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

include (CPack)
add_custom_target (dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
#Add RPM build support
include (UseRPMTools)
if (RPMTools_FOUND)
   RPMTools_ADD_RPM_TARGETS(appmenu ${CMAKE_SOURCE_DIR}/rpm/vala-panel-appmenu.spec.in)
   RPMTools_ADD_RPM_TARGETS(module ${CMAKE_SOURCE_DIR}/rpm/appmenu-gtk-module.spec.in)
   RPMTools_ADD_RPM_TARGETS(jayatana ${CMAKE_SOURCE_DIR}/rpm/java-appmenu.spec.in)
endif(RPMTools_FOUND)

# Configuration
configure_file (${CMAKE_SOURCE_DIR}/vapi/config.vala.in ${CMAKE_BINARY_DIR}/vapi/config.vala)

# Some definitions
add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")

# Vala
find_package (Vala 0.34 REQUIRED)
include (ValaPrecompile)

add_definitions(-DVALA_VERSION="${VALA_SHORTVER}")
#add_definitions(-w) #Suppress all GCC warnings
add_definitions(-Wall -Wextra -Wno-unused # Vala loves to create variables
                -Wno-unused-parameter
#		-pedantic
                -Wno-ignored-qualifiers
                -Wno-incompatible-pointer-types
                -Wno-missing-field-initializers
                -Wno-sign-compare) #Vala often forgot cast to GtkWidget or gpointer

find_package (PkgConfig)
find_package(GLIB2 2.50 REQUIRED COMPONENTS GOBJECT GIO GIO_UNIX GMODULE GTHREAD CODEGEN MKENUMS GENMARSHAL COMPILE_SCHEMAS COMPILE_RESOURCES)
include(GLibProgramHandlers)
find_package(GTK 3.22 REQUIRED COMPONENTS GDK GTK X11 WAYLAND)
find_package(BAMF 0.5.0 REQUIRED COMPONENTS LIB DAEMON)
if(${GLIB2_FOUND} AND ${GTK_FOUND})
    set(CORE_FOUND TRUE)
endif()

set(CORE_PACKAGES
  gtk+-3.0
  glib-2.0
  gio-2.0
  gio-unix-2.0
  gmodule-2.0
  libbamf3
  posix)

if(((${VALA_VERSION} VERSION_LESS "0.43.91") AND (${VALA_VERSION} VERSION_GREATER "0.43.0"))
    OR ((${VALA_VERSION} VERSION_LESS "0.42.6") AND (${VALA_VERSION} VERSION_GREATER "0.41.0"))
    OR ((${VALA_VERSION} VERSION_LESS "0.40.14") AND (${VALA_VERSION} VERSION_GREATER "0.39.0"))
    OR ((${VALA_VERSION} VERSION_LESS "0.36.18") AND (${VALA_VERSION} VERSION_GREATER "0.35.0")))
    set(ADDONS_PACKAGE gio-addons-2.0)
endif()

#set requred variables
set(TARGET_GLIB ${GLIB_VERSION_MAJOR}.${GLIB_VERSION_MINOR})
include(CMakeDependentOption)

#set build options
find_package(WNCK 3.4.8)
cmake_dependent_option(ENABLE_WNCK "Enable libwnck-related functions" ON
    "WNCK_FOUND" OFF)
add_feature_info(LibWnck ENABLE_WNCK "alternative supporting backend")
if (ENABLE_WNCK)
    set(WNCK_DEFINE -D WNCK)
    set(WNCK_PACKAGES libwnck-3.0)
    set(WNCK_TARGETS WNCK::WNCK)
endif()
pkg_check_modules(XFCE libxfce4panel-2.0 libxfconf-0 IMPORTED_TARGET)
cmake_dependent_option(ENABLE_XFCE "Enable Xfce Panel Integration" ON
    "XFCE_FOUND" OFF)
add_feature_info(Xfce ENABLE_XFCE "Xfce Panel Integration")

pkg_check_modules(MATE libmatepanelapplet-4.0>=1.20 IMPORTED_TARGET)
cmake_dependent_option(ENABLE_MATE "Enable mate-panel Integration" ON
    "MATE_FOUND" OFF)
add_feature_info(MATE ENABLE_MATE "MATE Panel Integration")

find_package(PEAS 1.14 COMPONENTS PEAS)
pkg_check_modules(VALAPANEL vala-panel>=0.4.89 IMPORTED_TARGET)
pkg_check_modules(BUDGIE budgie-1.0 IMPORTED_TARGET)

cmake_dependent_option(ENABLE_VALAPANEL "Enable Vala Panel Integration" ON
    "VALAPANEL_FOUND" OFF)
add_feature_info(ValaPanel ENABLE_VALAPANEL "Vala Panel Integration - 0.5.x")

cmake_dependent_option(ENABLE_BUDGIE "Enable budgie-desktop plugin" ON
    "BUDGIE_FOUND; PEAS_FOUND" OFF)
add_feature_info(Budgie ENABLE_BUDGIE "Budgie Desktop Integration")

add_subdirectory(subprojects)
ADD_SUBDIRECTORY(lib)
ADD_SUBDIRECTORY(applets)
add_subdirectory(data)
add_subdirectory(po)

feature_summary(WHAT ALL)

=== meson_options.txt ===
option('wnck', type: 'feature', value: 'auto', description: 'Alternative supporting backend and AUX functions')
option('valapanel', type: 'feature', value: 'auto', description: 'Vala Panel Integration - 0.5.x')
option('xfce', type: 'feature', value: 'auto', description: 'Xfce Panel Integration')
option('mate', type: 'feature', value: 'auto', description: 'MATE Panel Integration')
option('budgie', type: 'feature', value: 'auto', description: 'Budgie Desktop Integration')

option('registrar', type: 'feature', value: 'auto', description: 'DBusMenu registrar')
option('appmenu-gtk-module', type: 'feature', value: 'auto', description: 'Gtk+ module for AppMenu')
option('jayatana', type: 'feature', value: 'auto', description: 'Java support for global menus')

=== applets/CMakeLists.txt ===
include_directories(${CMAKE_BINARY_DIR}/lib)
set(PLUGIN_VALA_FILES
    valapanel-plugin-appmenu.vala
    xfce4-plugin-appmenu.vala
    mate-plugin-appmenu.vala
    budgie-plugin-appmenu.vala
    )
add_custom_target(plugin-files-ide SOURCES ${PLUGIN_VALA_FILES})
glib_compile_resources(RESOURCES
    source
        ../lib/libappmenu.gresource.xml
)

##########
# XFCE Part
##########
if (ENABLE_XFCE)
    vala_precompile(VALA_C_XFCE appmenu-xfce
        xfce4-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        libxfce4panel-2.0
        libxfconf-0
    OPTIONS
        --vapidir=${CMAKE_BINARY_DIR}/lib
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        ${WNCK_DEFINE}
    )
    add_library (appmenu-xfce MODULE
        ${VALA_C_XFCE}
        ${RESOURCES}
    )
    target_link_libraries (appmenu-xfce appmenu-core PkgConfig::XFCE)
    # Install plugin stuffs
    install(TARGETS appmenu-xfce DESTINATION ${CMAKE_INSTALL_LIBDIR}/xfce4/panel/plugins)
endif()
##########
# ValaPanel Part
##########
if(ENABLE_VALAPANEL)
    vala_precompile(VALA_C_VALAPANEL appmenu-valapanel
        valapanel-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        vala-panel
        libpeas-1.0
    OPTIONS
        --vapidir=${CMAKE_BINARY_DIR}/lib
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --vapidir=${CMAKE_BINARY_DIR}/dbusmenu
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        ${WNCK_DEFINE}
    )

    # Build library for plugins and application
    add_library (appmenu-valapanel MODULE
        ${VALA_C_VALAPANEL}
        ${RESOURCES}
    )
    set_target_properties(appmenu-valapanel PROPERTIES
        OUTPUT_NAME appmenu)
    target_link_libraries (appmenu-valapanel appmenu-core PkgConfig::VALAPANEL)
    # Install plugin stuffs
    install(TARGETS appmenu-valapanel DESTINATION ${CMAKE_INSTALL_LIBDIR}/vala-panel/applets)
endif()
##########
# Budgie Panel Part
##########
if(ENABLE_BUDGIE)
    vala_precompile(VALA_C_BUDGIE appmenu-budgie
        budgie-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        budgie-1.0
        libpeas-1.0
    OPTIONS
        --vapidir=${CMAKE_BINARY_DIR}/lib
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        ${WNCK_DEFINE}
    )

    # Build library for plugins and application
    add_library (appmenu-budgie MODULE
        ${VALA_C_BUDGIE}
        ${RESOURCES}
    )
    target_link_libraries (appmenu-budgie appmenu-core PEAS::PEAS PkgConfig::BUDGIE)
    # Install plugin stuffs
    install(TARGETS appmenu-budgie DESTINATION ${CMAKE_INSTALL_LIBDIR}/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin)
endif()
##########
# MATE Part
##########
if (ENABLE_MATE)
    vala_precompile(VALA_C_MATE appmenu-mate
        mate-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        libmatepanelapplet-4.0
    OPTIONS
        --vapidir=${CMAKE_BINARY_DIR}/lib
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        ${WNCK_DEFINE}
    )
    add_library (appmenu-mate MODULE
                ${VALA_C_MATE}
                ${RESOURCES}
    )
    target_link_libraries (appmenu-mate appmenu-core PkgConfig::MATE)
    # Install plugin stuffs
    install(TARGETS appmenu-mate DESTINATION ${CMAKE_INSTALL_LIBDIR}/mate-panel)
endif()

=== data/CMakeLists.txt ===
if (ENABLE_XFCE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/xfce4/panel/plugins)
endif()
if (ENABLE_MATE)
    add_schema("org.valapanel.appmenu.gschema.xml")
    configure_file(${CMAKE_SOURCE_DIR}/data/appmenu-mate.plugin.desktop.in ${CMAKE_SOURCE_DIR}/data/appmenu-mate.desktop.in)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-mate.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/mate-panel/applets/ RENAME org.vala-panel.appmenu.mate-panel-applet)
endif()
if (ENABLE_VALAPANEL)
    add_schema("org.valapanel.appmenu.gschema.xml")
    configure_file(${CMAKE_SOURCE_DIR}/data/appmenu.plugin.desktop.in ${CMAKE_SOURCE_DIR}/data/org.valapanel.appmenu.desktop.in @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.valapanel.appmenu.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/vala-panel/applets/ RENAME org.valapanel.appmenu.plugin)
endif()
if (ENABLE_BUDGIE)
    add_schema("org.valapanel.appmenu.gschema.xml")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-budgie.desktop DESTINATION ${CMAKE_INSTALL_LIBDIR}/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin RENAME appmenu-budgie.plugin)
endif()

=== lib/CMakeLists.txt ===
#####
# Core Parts (GResource, definitions)
#####
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_subdirectory(dbusmenu-importer)

set(CORE_VALA_FILES
    dbus-menu-importer.vapi
    launcher.vapi
    appmenu-abstractions.vala
    appmenu-bamf.vala
    registrar.vala
    menu-widget.vala
    helper-desktop.vala
    helper-dbus.vala
    helper-dbusmenu.vala
    helper-menumodel.vala
    ${CMAKE_BINARY_DIR}/vapi/config.vala
)
vala_precompile(VALA_C_CORE appmenu-core
    ${CORE_VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    ${ADDONS_PACKAGE}
    ${WNCK_PACKAGES}
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_CURRENT_BINARY_DIR}
    --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/dbusmenu-importer
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
    ${WNCK_DEFINE}
GENERATE_VAPI
    vala-panel-appmenu
)
include_directories(${CMAKE_SOURCE_DIR})
set(CORE_C_FILES
    launcher.c
    launcher.h
)
if(WNCK_FOUND)
	list(APPEND CORE_C_FILES
		matcher.c
		matcher.h
	)
endif()
add_library(appmenu-core STATIC ${CORE_C_FILES} ${VALA_C_CORE})
target_link_libraries (appmenu-core
    dbusmenu-importer
    GLIB2::GIO_UNIX
    GLIB2::GOBJECT
    GTK3::GTK
    GTK3::GDK
    BAMF::LIB
    ${WNCK_TARGETS}
    m)
set_target_properties(appmenu-core PROPERTIES
        POSITION_INDEPENDENT_CODE ON	# Compile this object code position independent.
)
add_custom_target(vala-files-ide SOURCES ${VALA_FILES_DBUSMENU} ${CORE_VALA_FILES})

=== po/CMakeLists.txt ===
include(Translations)
add_translations_directory("vala-panel-appmenu")
add_translations_catalog("vala-panel-appmenu"
    ../lib
    ../data
)

=== debian/changelog ===
vala-panel-appmenu (0.7.3+dfsg1-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/control:
    + Drop from B-D: libpeas-dev.

  [ Martin Wimpress ]
  * debian/control:
    + Drop Recommends: appmenu-qt. It has been removed from the Debian & UBuntu
      archives. https://wiki.debian.org/Qt4Removal
      (Closes: #935978).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 25 Nov 2019 21:11:13 +0100

vala-panel-appmenu (0.7.3+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/{control,compat}:
    + Switch to debhelper-compat notation, bump to DH compat level version 12.
  * debian/control:
    + Update B-Ds for this upstream release. Switch from cmake to meson.
    + Bump Standards-Version: to 4.4.0. No changes needed.
  * debian/rules:
    + Switch to 'meson' as build-system.
  * debian/patches:
    + Drop all patches, they were cmake related.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 07 Aug 2019 01:21:45 +0200

=== debian/control ===
Source: vala-panel-appmenu
Section: x11
Priority: optional
Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
Uploaders:
 Martin Wimpress <martin.wimpress@ubuntu.com>,
 Mike Gabriel <sunweaver@debian.org>,
 Debian+Ubuntu MATE Packaging Team <debian-mate@lists.debian.org>,
Build-Depends: budgie-core-dev,
               meson (>= 0.49.0),
               debhelper-compat (= 12),
               libbamf3-dev (>= 0.5.0),
               bamfdaemon (>= 0.5.0),
               libgtk-3-dev (>= 3.22.0),
               libmate-panel-applet-dev (>= 1.20),
               libvalapanel-dev (>= 0.4.89),
               libwnck-3-dev (>= 3.4.8),
               libxfce4panel-2.0-dev,
               libxfconf-0-dev,
               valac (>= 0.24.0),
               xfce4-panel-dev (>= 4.11.2),
Standards-Version: 4.4.0
Homepage: https://gitlab.com/vala-panel-project/vala-panel-appmenu
Vcs-Git: https://salsa.debian.org/debian-ayatana-team/vala-panel-appmenu.git
Vcs-Browser: https://salsa.debian.org/debian-edu-ayatana-team/vala-panel-appmenu

Package: budgie-appmenu-applet
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         appmenu-registrar (>= 0.7.1),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            appmenu-gtk2-module,
            appmenu-gtk3-module,
Description: Application Menu plugin for budgie-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for Budgie.

Package: xfce4-appmenu-plugin
Section: xfce
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         appmenu-registrar (>= 0.7.1),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            appmenu-gtk2-module,
            appmenu-gtk3-module,
Description: Application Menu plugin for xfce4-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for Xfce.

Package: mate-applet-appmenu
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         appmenu-registrar (>= 0.7.1),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            appmenu-gtk2-module,
            appmenu-gtk3-module,
Description: Application Menu plugin for mate-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for MATE.

Package: vala-panel-appmenu
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         appmenu-registrar (>= 0.7.1),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            appmenu-gtk2-module,
            appmenu-gtk3-module,
Description: Application Menu plugin for vala-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.

Package: vala-panel-appmenu-common
Architecture: all
Depends: ${misc:Depends},
Description: Common files for Application Menu plugins
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides common files.

=== debian/rules ===
#!/usr/bin/make -f

NULL=

DHFLAGS=--buildsystem=meson
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE = +dfsg1
VER  ?= $(subst $(DTYPE),,$(UVER))

%:
	dh $@ $(DHFLAGS)

override_dh_auto_build:
	dh_auto_build $(DHFLAGS)

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) -- \
	        -Dwnck=enabled \
	        -Dvalapanel=enabled \
	        -Dxfce=enabled \
	        -Dmate=enabled \
	        -Dbudgie=enabled \
	        $(NULL)

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/share/vala-panel-appmenu/doc/README.md
	rm debian/tmp/usr/share/vala-panel-appmenu/doc/LICENSE
	rmdir debian/tmp/usr/share/vala-panel-appmenu/doc/
	#mkdir -p $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie
	#mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin/* $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie

override_dh_makeshlibs:
	dh_makeshlibs -Xbudgie -Xmate -Xvala-panel -Xxfce4

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -f data/appmenu-mate.desktop.in
	rm -f data/appmenu.desktop.plugin.in

get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	    && tar -xf $(PKG)_$(VER).orig.tar.xz --directory $(PKG)-$(VER) --strip-components 1 \
	    || $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) \
	    && $(RM) -r -v \
	        _ccache/ \
	        rpm/ \
	        subprojects/ \
	        po/stamp-it \
	        $(NULL)
	$(RM) -v $(PKG)_$(VER).orig.tar.*
	@echo "# Packing..."
	    find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"

## vala-panel-appmenu 0.7.3.2+dfsg1

=== debian/changelog ===
vala-panel-appmenu (0.7.3.2+dfsg1-1ubuntu0.1) groovy; urgency=medium

  * Resolve segfault crash issues with apps like VSCode
    patches:
    0001-importer-small-fixes.patch
    0001-importer-process-events-after-layout-parse.-For-327.patch
    0001-importer-new-internal-layout.-Fixes-327.patch
    (LP: #1930615)

 -- David Mohammed <fossfreedom@ubuntu.com>  Thu, 03 Jun 2021 22:04:54 +0100

vala-panel-appmenu (0.7.3.2+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #951968).
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/control:
    + Bump DH compat level to version 13.
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Update versioned B-D: libvalapanel-dev (>= 0.4.92).
    + Add Rules-Requires-Root: field and set it to 'no'.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 23 Aug 2020 20:29:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,28 @@
 Source: vala-panel-appmenu
 Section: x11
 Priority: optional
-Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
 Uploaders:
  Martin Wimpress <martin.wimpress@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
  Debian+Ubuntu MATE Packaging Team <debian-mate@lists.debian.org>,
+ David Mohammed <fossfreedom@ubuntu.com>
 Build-Depends: budgie-core-dev,
                meson (>= 0.49.0),
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libbamf3-dev (>= 0.5.0),
                bamfdaemon (>= 0.5.0),
                libgtk-3-dev (>= 3.22.0),
                libmate-panel-applet-dev (>= 1.20),
-               libvalapanel-dev (>= 0.4.89),
+               libvalapanel-dev (>= 0.4.92),
                libwnck-3-dev (>= 3.4.8),
                libxfce4panel-2.0-dev,
                libxfconf-0-dev,
                valac (>= 0.24.0),
                xfce4-panel-dev (>= 4.11.2),
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://gitlab.com/vala-panel-project/vala-panel-appmenu
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/vala-panel-appmenu.git
 Vcs-Browser: https://salsa.debian.org/debian-edu-ayatana-team/vala-panel-appmenu

## vala-panel-appmenu 0.7.6+dfsg1

=== meson_options.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
-option('wnck', type: 'feature', value: 'auto', description: 'Alternative supporting backend and AUX functions')
+option('wm_backend', type: 'combo', choices: ['auto','wnck','bamf'], value: 'auto', description: 'Backend for appmenu')
+
 option('valapanel', type: 'feature', value: 'auto', description: 'Vala Panel Integration - 0.5.x')
 option('xfce', type: 'feature', value: 'auto', description: 'Xfce Panel Integration')
 option('mate', type: 'feature', value: 'auto', description: 'MATE Panel Integration')

=== debian/changelog ===
vala-panel-appmenu (0.7.6+dfsg1-7ubuntu2) plucky; urgency=medium

  * Add missing build dependency on libxfce4ui-2-dev.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 22 Mar 2025 21:08:10 -0500

vala-panel-appmenu (0.7.6+dfsg1-7ubuntu1) plucky; urgency=medium

  * Remove obsolete runtime depends on appmenu-gtk2-module (Closes: #1095102).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 22 Mar 2025 16:52:10 -0500

vala-panel-appmenu (0.7.6+dfsg1-7) unstable; urgency=medium

  * Team upload
  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 04 Oct 2024 20:54:06 -0400

vala-panel-appmenu (0.7.6+dfsg1-6) experimental; urgency=medium

  * Team upload
  * Revert dropping Budgie plugin

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 10 Jul 2024 17:01:11 -0400

vala-panel-appmenu (0.7.6+dfsg1-5) unstable; urgency=medium

  * Team upload

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Jeremy Bícha ]
  * Temporarily disable Budgie plugin
  * Bump Standards Version to 4.6.2

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 10 Jul 2024 16:59:43 -0400

vala-panel-appmenu (0.7.6+dfsg1-4) unstable; urgency=medium

  * debian/patches:
    + Add 0001_Update-LINGUAS.patch. Drop duplicate translations. Fixes FTBFS.
      (Relates to: #998558).
  * debian/rules:
    + Enforce bamf backend, don't build with wnck enabled (probably wrong
      syntax, now spotted by recent meson version). (Closes: #998558).
  * debian/control:
    + Drop from B-D: libwnck-3-dev.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 29 Nov 2021 15:46:44 +0100

vala-panel-appmenu (0.7.6+dfsg1-3) unstable; urgency=medium

  * debian/watch:
    + Fix broken watch file; possibly due to changes in gitlab.com.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 04 Feb 2021 00:58:00 +0100

vala-panel-appmenu (0.7.6+dfsg1-2) unstable; urgency=medium

  * debian/control:
    + Drop B-D xfce4-panel-dev. Pkg not available anymore since XFCE4 4.16.
      (Closes: #978227).
    + Bump Standards-Version: to 4.5.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 09 Jan 2021 23:52:54 +0100

vala-panel-appmenu (0.7.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 31 Oct 2020 10:09:47 +0100

vala-panel-appmenu (0.7.5+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Update versioned B-D on meson (>= 0.51.0).
    + Add versioned B-D on libglib2.0-dev (>= 2.52.0).
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/{mate-applet-appmenu,xfce4-appmenu-plugin}*:
    + Add scripts for tweaking gsettings required to enable/disable appmenu
      support in MATE and XFCE4. (Closes: #930572).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 19 Oct 2020 15:00:47 +0200

=== debian/control ===
--- 
+++ 
@@ -7,38 +7,36 @@
  Martin Wimpress <martin.wimpress@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
  Debian+Ubuntu MATE Packaging Team <debian-mate@lists.debian.org>,
- David Mohammed <fossfreedom@ubuntu.com>
-Build-Depends: budgie-core-dev,
-               meson (>= 0.49.0),
-               debhelper-compat (= 13),
-               libbamf3-dev (>= 0.5.0),
-               bamfdaemon (>= 0.5.0),
-               libgtk-3-dev (>= 3.22.0),
-               libmate-panel-applet-dev (>= 1.20),
+Build-Depends: debhelper-compat (= 13),
+               budgie-core-dev,
+               meson (>= 0.51.0),
+               libbamf3-dev,
+               bamfdaemon,
+               libglib2.0-dev,
+               libgtk-3-dev,
+               libmate-panel-applet-dev,
                libvalapanel-dev (>= 0.4.92),
-               libwnck-3-dev (>= 3.4.8),
                libxfce4panel-2.0-dev,
+               libxfce4ui-2-dev,
                libxfconf-0-dev,
-               valac (>= 0.24.0),
-               xfce4-panel-dev (>= 4.11.2),
-Standards-Version: 4.5.0
+               valac,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/vala-panel-project/vala-panel-appmenu
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/vala-panel-appmenu.git
-Vcs-Browser: https://salsa.debian.org/debian-edu-ayatana-team/vala-panel-appmenu
+Vcs-Browser: https://salsa.debian.org/debian-ayatana-team/vala-panel-appmenu
 
 Package: budgie-appmenu-applet
 Architecture: any
 Depends: bamfdaemon,
          vala-panel-appmenu-common (= ${source:Version}),
-         appmenu-registrar (>= 0.7.1),
+         appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: appmenu-qt5,
             libdbusmenu-glib4,
             libdbusmenu-gtk3-4,
             libdbusmenu-gtk4,
-            appmenu-gtk2-module,
             appmenu-gtk3-module,
 Description: Application Menu plugin for budgie-panel
  This is an Application Menu (Global Menu) plugin. It is built using
@@ -52,14 +50,13 @@
 Architecture: any
 Depends: bamfdaemon,
          vala-panel-appmenu-common (= ${source:Version}),
-         appmenu-registrar (>= 0.7.1),
+         appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: appmenu-qt5,
             libdbusmenu-glib4,
             libdbusmenu-gtk3-4,
             libdbusmenu-gtk4,
-            appmenu-gtk2-module,
             appmenu-gtk3-module,
 Description: Application Menu plugin for xfce4-panel
  This is an Application Menu (Global Menu) plugin. It is built using
@@ -72,14 +69,13 @@
 Architecture: any
 Depends: bamfdaemon,
          vala-panel-appmenu-common (= ${source:Version}),
-         appmenu-registrar (>= 0.7.1),
+         appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: appmenu-qt5,
             libdbusmenu-glib4,
             libdbusmenu-gtk3-4,
             libdbusmenu-gtk4,
-            appmenu-gtk2-module,
             appmenu-gtk3-module,
 Description: Application Menu plugin for mate-panel
  This is an Application Menu (Global Menu) plugin. It is built using
@@ -92,14 +88,13 @@
 Architecture: any
 Depends: bamfdaemon,
          vala-panel-appmenu-common (= ${source:Version}),
-         appmenu-registrar (>= 0.7.1),
+         appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: appmenu-qt5,
             libdbusmenu-glib4,
             libdbusmenu-gtk3-4,
             libdbusmenu-gtk4,
-            appmenu-gtk2-module,
             appmenu-gtk3-module,
 Description: Application Menu plugin for vala-panel
  This is an Application Menu (Global Menu) plugin. It is built using

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 NULL=
 
-DHFLAGS=--buildsystem=meson
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 include /usr/share/dpkg/buildflags.mk
 
@@ -15,22 +14,18 @@
 VER  ?= $(subst $(DTYPE),,$(UVER))
 
 %:
-	dh $@ $(DHFLAGS)
-
-override_dh_auto_build:
-	dh_auto_build $(DHFLAGS)
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure $(DHFLAGS) -- \
-	        -Dwnck=enabled \
-	        -Dvalapanel=enabled \
+	dh_auto_configure -- \
+	        -Dwm_backend=bamf \
+		-Dvalapanel=enabled \
 	        -Dxfce=enabled \
 	        -Dmate=enabled \
 	        -Dbudgie=enabled \
 	        $(NULL)
 
-override_dh_auto_install:
-	dh_auto_install
+execute_after_dh_auto_install:
 	rm debian/tmp/usr/share/vala-panel-appmenu/doc/README.md
 	rm debian/tmp/usr/share/vala-panel-appmenu/doc/LICENSE
 	rmdir debian/tmp/usr/share/vala-panel-appmenu/doc/
@@ -40,11 +35,7 @@
 override_dh_makeshlibs:
 	dh_makeshlibs -Xbudgie -Xmate -Xvala-panel -Xxfce4
 
-override_dh_missing:
-	dh_missing --fail-missing
-
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_auto_clean:
 	rm -f data/appmenu-mate.desktop.in
 	rm -f data/appmenu.desktop.plugin.in

=== debian/watch ===
version=4
https://gitlab.com/vala-panel-project/vala-panel-appmenu/-/tags/?([\d\.]+) .*/uploads/.*/vala-panel-appmenu-?([\d\.]+)\.tar\.xz

## vala-panel-appmenu 24.05+dfsg

=== debian/changelog ===
vala-panel-appmenu (24.05+dfsg-2) unstable; urgency=medium

  * debian/control:
    + Update versioned B-D: libvalapanel-dev (>= 24.03).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 09 Apr 2025 21:11:12 +0200

vala-panel-appmenu (24.05+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - xfce4-appmenu-plugin: Make appmenu expand work with updated Xfce 4.20.
      (Closes:  #1094010).
  * debian/patches:
    + Drop 0001_Update-LINGUAS.patch. Not required anymore.
    + Add 2001_build-appmenu-glib-translator-statically.patch. Build and link
      appmenu-glib-translator statically.
  * debian/watch:
    + Adjust to new syntax as required GitLab.
  * debian/control:
    + Drop reference to appmenu-gtk2-module. (Closes: #1095102).
    + Add B-D: libxfce4ui-2-dev. (Although this should be better handled by
      libxfce4panel-2.0-dev). (Closes: #1091049).
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + Add to B-D: libwnck-3-dev.
    + Make package binNMU'able (fix relation between arch:any and arch:all
      bin:pkgs).
  * debian/{control,rules}:
    + Drop bamf(daemon) as B-D / D.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 09 Apr 2025 18:36:51 +0200

## vala-panel-appmenu 25.04%2Bdfsg

=== debian/changelog ===
vala-panel-appmenu (25.04+dfsg-3ubuntu1) resolute; urgency=medium

  * Disable Budgie plugin to fix build failure

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 08 Feb 2026 23:35:39 -0500

vala-panel-appmenu (25.04+dfsg-3) experimental; urgency=medium

  * Team upload
  * Revert removing Budgie plugin

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 14 Nov 2025 06:48:54 -0500

vala-panel-appmenu (25.04+dfsg-2) unstable; urgency=medium

  * Team upload
  * Add Build-Depends: gobject-introspection
  * Remove unsatisfiable Recommends: appmenu-qt5, libdbusmenu-gtk4
    (Closes: #1112018, #1115680, #1116078, #1116137)
  * Temporarily disable Budgie plugin

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 14 Nov 2025 06:46:58 -0500

vala-panel-appmenu (25.04+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 04 May 2025 18:36:43 +0200

## vala-panel-appmenu 25.04+dfsg

=== meson_options.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-option('wm_backend', type: 'combo', choices: ['auto','wnck','bamf'], value: 'auto', description: 'Backend for appmenu')
+option('wm_backend', type: 'combo', choices: ['auto','wnck'], value: 'auto', description: 'Backend for appmenu')
 
 option('valapanel', type: 'feature', value: 'auto', description: 'Vala Panel Integration - 0.5.x')
 option('xfce', type: 'feature', value: 'auto', description: 'Xfce Panel Integration')

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: vala-panel-appmenu
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
+Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
 Uploaders:
  Martin Wimpress <martin.wimpress@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
@@ -10,17 +9,16 @@
 Build-Depends: debhelper-compat (= 13),
                budgie-core-dev,
                meson (>= 0.51.0),
-               libbamf3-dev,
-               bamfdaemon,
                libglib2.0-dev,
                libgtk-3-dev,
                libmate-panel-applet-dev,
-               libvalapanel-dev (>= 0.4.92),
+               libvalapanel-dev (>= 24.03),
+               libwnck-3-dev,
                libxfce4panel-2.0-dev,
                libxfce4ui-2-dev,
                libxfconf-0-dev,
                valac,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/vala-panel-project/vala-panel-appmenu
 Vcs-Git: https://salsa.debian.org/debian-ayatana-team/vala-panel-appmenu.git
@@ -28,8 +26,7 @@
 
 Package: budgie-appmenu-applet
 Architecture: any
-Depends: bamfdaemon,
-         vala-panel-appmenu-common (= ${source:Version}),
+Depends: vala-panel-appmenu-common (>= ${source:Version}),
          appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
@@ -48,8 +45,7 @@
 Package: xfce4-appmenu-plugin
 Section: xfce
 Architecture: any
-Depends: bamfdaemon,
-         vala-panel-appmenu-common (= ${source:Version}),
+Depends: vala-panel-appmenu-common (>= ${source:Version}),
          appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
@@ -67,8 +63,7 @@
 
 Package: mate-applet-appmenu
 Architecture: any
-Depends: bamfdaemon,
-         vala-panel-appmenu-common (= ${source:Version}),
+Depends: vala-panel-appmenu-common (>= ${source:Version}),
          appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},
@@ -86,8 +81,7 @@
 
 Package: vala-panel-appmenu
 Architecture: any
-Depends: bamfdaemon,
-         vala-panel-appmenu-common (= ${source:Version}),
+Depends: vala-panel-appmenu-common (>= ${source:Version}),
          appmenu-registrar,
          ${misc:Depends},
          ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
 PKG   = $(DEB_SOURCE)
 UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
-DTYPE = +dfsg1
+DTYPE = +dfsg
 VER  ?= $(subst $(DTYPE),,$(UVER))
 
 %:
@@ -18,7 +18,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	        -Dwm_backend=bamf \
+	        -Dwm_backend=auto \
 		-Dvalapanel=enabled \
 	        -Dxfce=enabled \
 	        -Dmate=enabled \
@@ -26,9 +26,7 @@
 	        $(NULL)
 
 execute_after_dh_auto_install:
-	rm debian/tmp/usr/share/vala-panel-appmenu/doc/README.md
-	rm debian/tmp/usr/share/vala-panel-appmenu/doc/LICENSE
-	rmdir debian/tmp/usr/share/vala-panel-appmenu/doc/
+	rm $(CURDIR)/debian/tmp/usr/share/licenses/vala-panel-appmenu/LICENSE
 	#mkdir -p $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie
 	#mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin/* $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie
 
@@ -48,14 +46,17 @@
 	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
 	@echo "# Extracting..."
 	mkdir $(PKG)-$(VER) \
-	    && tar -xf $(PKG)_$(VER).orig.tar.xz --directory $(PKG)-$(VER) --strip-components 1 \
+	    && TARFILE=$$(find $(PKG)_$(VER).orig.tar.* | head -n1) \
+	    && tar -xf $${TARFILE} --directory $(PKG)-$(VER) --strip-components 1 \
 	    || $(RM) -r $(PKG)-$(VER)
 	@echo "# Cleaning-up..."
 	cd $(PKG)-$(VER) \
 	    && $(RM) -r -v \
 	        _ccache/ \
 	        rpm/ \
-	        subprojects/ \
+	        subprojects/appmenu-gtk-module \
+	        subprojects/jayatana \
+	        subprojects/registrar \
 	        po/stamp-it \
 	        $(NULL)
 	$(RM) -v $(PKG)_$(VER).orig.tar.*

=== debian/watch ===
version=4
opts="searchmode=plain, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/vala-panel-project/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
